--TaroNuke's Mod system. Taken from Puuro's 'Hopes And Dreams' file.
--Because I don't know how to program a mods system, and I don't want to right now.
LoadActor("mods-taro.lua")

--Screen ratios, helpful for making things work no matter what. -Kid
local prefix_sdwidth_ratio = (480*(SCREEN_WIDTH/SCREEN_HEIGHT))/640
local prefix_width_ratio = SCREEN_WIDTH/640
local prefix_height_ratio = SCREEN_HEIGHT/480
--Because 5.2's notefield works differently from 5.0/5.1's notefield. -Kid
local is_5_2 = false
return Def.ActorFrame{
  Name= "actor_c",
  Def.Quad{
    Name= "actor_d",
    InitCommand= cmd(visible,true),
    OnCommand= cmd(sleep,1000),
  },
  Def.Quad{
    Name= "actor_e",
    InitCommand= cmd(visible,true),
    OnCommand= function(self)
				p1_options = GAMESTATE:GetPlayerState(0):GetPlayerOptions('ModsLevel_Song');
				p2_options = GAMESTATE:GetPlayerState(1):GetPlayerOptions('ModsLevel_Song');
				prefix_path = SONGMAN:FindSong(GAMESTATE:GetCurrentSong():GetDisplayFullTitle()):GetSongDir();
				fgcurcommand = 1;
				checked = false;
				prefix_time = 0;

				prefix_curmessage = 1;

				--We need to check for 5.2 now, before the mod table is formed. -Kid
				for i=1,2 do
					if SCREENMAN:GetTopScreen():GetChild('PlayerP'..i) then
						if SCREENMAN:GetTopScreen():GetChild('PlayerP'..i):GetChild('NoteField').set_skin then
							is_5_2 = true--We're in 5.2. This changes some things. -Kid
						end
					end
				end
				local prefix_hallwaymult = is_5_2 and (7.2/15) or (10/15)

				prefix_messages = {
				{0.000,'GetProxy'},
				{0.000,'Store'},
				{0.786,'BuzzBeginning'},

				{33.094,'BlindOn'},--Replaces Blind. -Kid
				{36.555,'BlindOff'},

				{41.603,'MiniToBuzz'},

				{44.920,'XStretch'},
				{46.074,'YStretch'},

				{46.940,'BuzzBounce'},

				{58.350,'Vortex'},

				{58.477,'BuzzBeginning'},
				{58.477,'BuzzBeginningRatio'},--Because movement. -Kid

				{58.478,'VortexSpin'},

				{67.132,'ChangeZPosition'},

				{67.709,'Perspective'},
				{67.709,'PerspectiveJudCom'},

				{94.824,'HideVortex'},

				{44.920+58.847,'XStretch'},
				{46.074+58.847,'YStretch'},

				{105.786,'BuzzBounce'},
				{119.344,'BlindOn'},--One last Blind. -Kid
				};


				prefix_mods = {

				{0,200,'1.9x,-999999% Cover,*10000 No Beat','end'},

				{0,0.497,'*10000 200% Mini,','end'},
				{0.497,0.786,'*16 -250% Mini,*0.9 25% Flip,','end'},
				{0.786,10.017,'*0.3 No Mini,*0.03 No Flip,','end'},
				{0.786,0.930,'*32 500% Drunk,*32 500% Tipsy,','end'},
				{0.930,10.017,'*0.5 No Drunk,*0.5 No Tipsy,','end'},
				--{10.017,58.478,'','end'},

				{9.440,0.072,'*14 Invert,','len'},
				{9.440+240/208/16*1,0.072,'*14 No Invert,*14 Flip,','len'},
				{9.440+240/208/16*2,0.072,'*14 No Invert,*14 No Flip,','len'},
				{9.440+240/208/16*3,0.072,'*14 -100% Invert,*14 Flip,','len'},
				{9.440+240/208/16*4,0.072,'*28 Invert,*14 No Flip,','len'},
				{9.440+240/208/16*5,0.072,'*14 No Invert,*14 No Flip,','len'},
				{9.440+240/208/16*6,0.072,'*14 No Invert,*14 -100% Flip,','len'},
				{9.440+240/208/16*7,0.250,'*14 No Invert,*14 No Flip,','len'},

				{10.017,18.094,'*0.4 250% Hallway,*0.8 -500% Mini,*0.4 1x','end'},
				{10.305,18.094,'*0.07 35% Flip','end'},

				{9.872,14.199,'*10000 200% Beat','end'},

				{14.199,18.670,'*96 No Tipsy','end'},
				{14.199,240/208/24,'*64 400% Tipsy','len'},
				{14.488,240/208/24,'*64 -400% Tipsy','len'},
				{14.632,240/208/24,'*64 400% Tipsy','len'},
				{14.776,240/208/24,'*64 -400% Tipsy','len'},
				{14.920,240/208/24,'*64 400% Tipsy','len'},
				{15.065,240/208/24,'*64 -400% Tipsy','len'},
				{15.209,240/208/24,'*64 400% Tipsy','len'},
				{15.353,240/208/24,'*64 -400% Tipsy','len'},
				{15.425,240/208/24,'*64 400% Tipsy','len'},
				{15.497,240/208/24,'*64 -400% Tipsy','len'},
				{15.642,240/208/24,'*64 400% Tipsy','len'},
				{15.786,240/208/24,'*64 -400% Tipsy','len'},
				{15.930,240/208/24,'*64 400% Tipsy','len'},
				{16.074,240/208/24,'*64 -400% Tipsy','len'},
				{16.219,240/208/24,'*64 400% Tipsy','len'},
				{16.363,240/208/24,'*64 -400% Tipsy','len'},
				{16.435,240/208/24,'*64 400% Tipsy','len'},
				{16.507,240/208/24,'*64 -400% Tipsy','len'},
				{16.579,240/208/24,'*64 400% Tipsy','len'},
				{16.651,240/208/24,'*64 -400% Tipsy','len'},
				{16.795,240/208/24,'*64 400% Tipsy','len'},

				{18.094,19.247,'*64 No Drunk,*0.35 No Flip,*5 No Mini,*2.5 Overhead','end'},


				{18.670,0.072,'*14 Invert,','len'},
				{18.670+240/208/16*1,0.072,'*14 No Invert,*14 Flip,','len'},
				{18.670+240/208/16*2,0.072,'*14 No Invert,*14 No Flip,','len'},
				{18.670+240/208/16*3,0.072,'*14 -100% Invert,*14 Flip,','len'},
				{18.670+240/208/16*4,0.072,'*28 Invert,*14 No Flip,','len'},
				{18.670+240/208/16*5,0.072,'*14 No Invert,*14 No Flip,','len'},
				{18.670+240/208/16*6,0.072,'*14 No Invert,*14 -100% Flip,','len'},
				{18.670+240/208/16*7,0.250,'*14 No Invert,*21 50% Flip,','len'},

				{19.247,25.594,'*10000 50% Flip,','end'},
				{25.594,25.882,'*2 No Flip,','end'},

				{25.882,30.497,'*6 175% Mini,*12 -300% Flip,*1.5 1.5x','end'},
				{30.497,31.000,'*6 No Mini,*12 No Flip,*1.5 1.9x','end'},

				{26.026,27.469,'*10000 2000% Beat','end'},
				{28.334,30.353,'*10000 2000% Beat','end'},

				{27.469,240/208/16,'*32 -200% Flip','len'},
				{27.541,240/208/16,'*32 -100% Flip','len'},
				{27.613,240/208/8,'*32 No Flip','len'},
				{27.757,240/208/16,'*32 -60% Flip','len'},
				{27.829,240/208/16,'*32 -120% Flip','len'},
				{27.901,240/208/16,'*32 -180% Flip','len'},
				{27.973,240/208/16,'*32 -240% Flip','len'},
				{28.045,240/208/8,'*32 -300% Flip','len'},
				{28.190,240/208/8,'*32 No Flip','len'},
				{28.334,240/208/8,'*32 -300% Flip','len'},

				{30.642,31.219,'*10000 200% Beat','end'},

				{31.363,240/208/8,'*16 150% Mini','len'},
				{31.507,240/208/8,'*16 No Mini','len'},
				{31.651,240/208/8,'*16 150% Mini','len'},
				{31.795,240/208/8,'*16 No Mini','len'},

				{31.940,33.094,'*48 No Drunk,*48 No Tipsy,*12 No Mini,*12 No Flip','end'},
				{31.940,240/208/16*3,'*48 250% Drunk,*48 250% Tipsy,*12 63% Mini,*12 -63% Flip','len'},
				{32.372,240/208/16*3,'*48 -250% Drunk,*48 -250% Tipsy,*12 63% Mini,*12 -63% Flip','len'},
				{32.805,240/208/8,'*48 250% Drunk,*48 250% Tipsy,*12 63% Mini,*12 -63% Flip','len'},

				{33.094,34.247,'*1.25 200% Mini','end'},
				--{33.094,36.555,'Blind','end'},--Replaced with MessageCommands. -Kid
				{34.247+240/208/8*0,240/208/8,'*1 No Mini','len'},
				{34.247+240/208/8*1,240/208/8,'*2 No Mini','len'},
				{34.247+240/208/8*2,240/208/8,'*3 No Mini','len'},
				{34.247+240/208/8*3,240/208/8,'*4 No Mini','len'},
				{34.247+240/208/8*4,240/208/8,'*5 No Mini','len'},
				{34.247+240/208/8*5,240/208/8,'*6 No Mini','len'},
				{34.247+240/208/8*6,240/208/8,'*7 No Mini','len'},
				{34.247+240/208/8*7,240/208/8,'*8 No Mini','len'},
				{34.247+240/208/8*8,240/208/8,'*9 No Mini','len'},
				{34.247+240/208/8*9,240/208/8,'*10 No Mini','len'},
				{34.247+240/208/8*10,240/208/8,'*11 No Mini','len'},
				{34.247+240/208/8*11,240/208/8,'*12 No Mini','len'},
				{34.247+240/208/8*12,240/208/8,'*13 No Mini','len'},
				{34.247+240/208/8*13,240/208/8,'*14 No Mini','len'},
				{34.247+240/208/8*14,240/208/8,'*15 No Mini','len'},
				{34.247+240/208/8*15,37.709,'*16 No Mini','end'},
				{34.247+240/208/8*0,240/208/16,'*1 200% Mini','len'},
				{34.247+240/208/8*1,240/208/16,'*2 200% Mini','len'},
				{34.247+240/208/8*2,240/208/16,'*3 200% Mini','len'},
				{34.247+240/208/8*3,240/208/16,'*4 200% Mini','len'},
				{34.247+240/208/8*4,240/208/16,'*5 200% Mini','len'},
				{34.247+240/208/8*5,240/208/16,'*6 200% Mini','len'},
				{34.247+240/208/8*6,240/208/16,'*7 200% Mini','len'},
				{34.247+240/208/8*7,240/208/16,'*8 200% Mini','len'},
				{34.247+240/208/8*8,240/208/16,'*9 200% Mini','len'},
				{34.247+240/208/8*9,240/208/16,'*10 200% Mini','len'},
				{34.247+240/208/8*10,240/208/16,'*11 200% Mini','len'},
				{34.247+240/208/8*11,240/208/16,'*12 200% Mini','len'},
				{34.247+240/208/8*12,240/208/16,'*13 200% Mini','len'},
				{34.247+240/208/8*13,240/208/16,'*14 200% Mini','len'},
				{34.247+240/208/8*14,240/208/16,'*15 200% Mini','len'},
				{34.247+240/208/8*15,240/208/16,'*16 200% Mini','len'},

				{37.565,41.603,'*10000 200% Beat','end'},

				{37.709,44.055,'*'..12*prefix_sdwidth_ratio..' '..600*prefix_sdwidth_ratio..'% Bumpy','end'},--Scaled Bumpy. -Kid
				{41.315,42.324,'*'..12*prefix_sdwidth_ratio..' No Bumpy','end'},
				{44.055,45.000,'*'..12*prefix_sdwidth_ratio..' No Bumpy','end'},
				{44.055,240/208/8,'*32 75% Mini','len'},
				{44.199,240/208/8,'*32 150% Mini','len'},
				{44.344,240/208/16,'*32 Mini','len'},
				{44.416,240/208/16,'*32 50% Mini','len'},
				{44.488,240/208/16,'*32 No Mini','len'},

				{41.603,240/208/4,'*32 1000% Dizzy','len'},
				{41.892,240/208/2,'*32 No Dizzy','len'},

				{42.180,44.488,'*10000 200% Beat','end'},

				{44.776,240/208/4,'*32 125% Drunk,*32 125% Tipsy','len'},
				{45.065,240/208/8,'*32 -125% Drunk,*32 -125% Tipsy','len'},
				{45.209,240/208/16*3,'*32 125% Drunk,*32 125% Tipsy','len'},
				{45.425,240/208/16*3,'*32 -125% Drunk,*32 -125% Tipsy','len'},
				{45.642,240/208/4,'*32 125% Drunk,*32 125% Tipsy','len'},
				{45.930,240/208/4,'*16 No Drunk,*16 No Tipsy','len'},

				{49.247,51.555,'*20 No Mini','end'},
				{49.247,240/208/16,'*20 200% Mini','len'},
				{49.392,240/208/16,'*20 200% Mini','len'},
				{49.680,240/208/16,'*20 200% Mini','len'},
				{49.969,240/208/16,'*20 200% Mini','len'},
				{50.257,240/208/16,'*20 200% Mini','len'},
				{50.545,240/208/16,'*20 200% Mini','len'},
				{50.834,240/208/16,'*20 200% Mini','len'},

				{50.257,240/208/8,'*12 Distant','len'},
				{50.545,240/208/8,'*12 200% Distant','len'},
				{50.834,240/208/8,'*24 Overhead','len'},

				{51.411,56.026,'*10000 200% Beat','end'},

				{51.555,240/208/4,'*8 200% Hallway','len'},
				{51.555+240/208/4*1,240/208/4,'*16 200% Distant','len'},
				{51.555+240/208/4*2,240/208/4,'*16 200% Hallway','len'},
				{51.555+240/208/4*3,240/208/4,'*16 200% Distant','len'},
				{51.555+240/208/4*4,240/208/4,'*16 200% Hallway','len'},
				{51.555+240/208/4*5,240/208/4,'*16 200% Distant','len'},
				{51.555+240/208/4*6,240/208/4,'*16 200% Hallway','len'},
				{51.555+240/208/4*7,240/208/4,'*8 Overhead','len'},

				{53.863,56.170,'*'..8*prefix_sdwidth_ratio..' '..400*prefix_sdwidth_ratio..'% Bumpy,*2 Boost','end'},--Scaled Bumpy. -Kid
				{56.170,58.478,'*'..8*prefix_sdwidth_ratio..' No Bumpy,*2 No Boost','end'},

				{56.170+240/208/8*0,240/208/8,'*16 24% Mini','len'},
				{56.170+240/208/8*1,240/208/8,'*16 48% Mini','len'},
				{56.170+240/208/8*2,240/208/8,'*16 72% Mini','len'},
				{56.170+240/208/8*3,240/208/8,'*16 96% Mini','len'},
				{56.170+240/208/8*4,240/208/8,'*16 120% Mini','len'},
				{56.170+240/208/8*5,240/208/8,'*16 144% Mini','len'},
				{56.170+240/208/8*6,240/208/8,'*16 168% Mini','len'},
				{56.170+240/208/8*7,240/208/8,'*16 192% Mini','len'},
				{57.324+240/208/16*0,240/208/16,'*16 176% Mini','len'},
				{57.324+240/208/16*1,240/208/16,'*16 160% Mini','len'},
				{57.324+240/208/16*2,240/208/16,'*16 144% Mini','len'},
				{57.324+240/208/16*3,240/208/16,'*16 128% Mini','len'},
				{57.324+240/208/16*4,240/208/16,'*16 112% Mini','len'},
				{57.324+240/208/16*5,240/208/16,'*16 96% Mini','len'},
				{57.324+240/208/16*6,240/208/16,'*16 80% Mini','len'},
				{57.324+240/208/16*7,240/208/16,'*16 64% Mini','len'},
				{57.324+240/208/16*8,240/208/16,'*16 48% Mini','len'},
				{57.324+240/208/16*9,240/208/16,'*16 32% Mini','len'},
				{57.324+240/208/16*10,240/208/16,'*16 16% Mini','len'},
				{57.324+240/208/16*11,240/208/16,'*16 No Mini','len'},

				{58.478,67.132,'*0.125 No Mini,*0.25 No Drunk','end'},
				{58.478,240/208/8,'*8 Mini,*16 200% Drunk','len'},

				{67.132,0.072,'*14 Invert,','len'},
				{67.132+240/208/16*1,0.072,'*14 No Invert,*14 Flip,','len'},
				{67.132+240/208/16*2,0.072,'*14 No Invert,*14 No Flip,','len'},
				{67.132+240/208/16*3,0.072,'*14 -100% Invert,*14 Flip,','len'},
				{67.132+240/208/16*4,0.072,'*28 Invert,*14 No Flip,','len'},
				{67.132+240/208/16*5,0.072,'*14 No Invert,*14 No Flip,','len'},
				{67.132+240/208/16*6,0.072,'*14 No Invert,*14 -100% Flip,','len'},
				{67.132+240/208/16*7,0.250,'*14 No Invert,*14 No Flip,','len'},

				{67.132,94.824,'*2 Mini,*2 1.5x','end'},
				{67.709,94.824,'*'..(0.5*prefix_hallwaymult)..' '..(375*prefix_hallwaymult)..'% Hallway,*0.1 25% Brake','end'},--Too much hallway, so dial it back. -Kid

				{85.882,94.824,'25% Bumpy,25% Drunk','end'},
				{94.824,96.555,'*'..2.5*prefix_hallwaymult..' Overhead','end'},--Scale reset rate. -Kid
				{95.401,103.334,'*2 0.4x,Hidden,Sudden,*10000 -50% HiddenOffset,*10000 -50% SuddenOffset','end'},
				{96.555,100.594,'*0.66 400% Centered','end'},
				{100.161,100.594,'*2 No Centered,*2 No Hidden,*2 No Sudden','end'},
				{100.594,100.882,'*10000 Reverse,*10000 No Centered,*2 Hidden,*2 Sudden','end'},
				{100.882,103.334,'*10000 Reverse,*0.66 400% Centered','end'},
				{103.334,104.000,'*4 1.9x,*4 No Reverse,*6 No Centered,*4 No Hidden,*4 No Sudden','end'},

				{58.847+44.776,240/208/4,'*32 125% Drunk,*32 125% Tipsy','len'},
				{58.847+45.065,240/208/8,'*32 -125% Drunk,*32 -125% Tipsy','len'},
				{58.847+45.209,240/208/16*3,'*32 125% Drunk,*32 125% Tipsy','len'},
				{58.847+45.425,240/208/16*3,'*32 -125% Drunk,*32 -125% Tipsy','len'},
				{58.847+45.642,240/208/4,'*32 125% Drunk,*32 125% Tipsy','len'},
				{58.847+45.930,240/208/4,'*16 No Drunk,*16 No Tipsy','len'},

				{58.847+49.247,58.847+51.555,'*20 No Mini','end'},
				{58.847+49.247,240/208/16,'*20 200% Mini','len'},
				{58.847+49.392,240/208/16,'*20 200% Mini','len'},
				{58.847+49.680,240/208/16,'*20 200% Mini','len'},
				{58.847+49.969,240/208/16,'*20 200% Mini','len'},
				{58.847+50.257,240/208/16,'*20 200% Mini','len'},
				{58.847+50.545,240/208/16,'*20 200% Mini','len'},
				{58.847+50.834,240/208/16,'*20 200% Mini','len'},

				{58.847+50.257,240/208/8,'*12 Distant','len'},
				{58.847+50.545,240/208/8,'*12 200% Distant','len'},
				{58.847+50.834,240/208/8,'*24 Overhead','len'},

				{58.847+51.411,58.847+56.026,'*10000 200% Beat','end'},

				{58.847+51.555,240/208/4,'*8 200% Hallway','len'},
				{58.847+51.555+240/208/4*1,240/208/4,'*16 200% Distant','len'},
				{58.847+51.555+240/208/4*2,240/208/4,'*16 200% Hallway','len'},
				{58.847+51.555+240/208/4*3,240/208/4,'*16 200% Distant','len'},
				{58.847+51.555+240/208/4*4,240/208/4,'*16 200% Hallway','len'},
				{58.847+51.555+240/208/4*5,240/208/4,'*16 200% Distant','len'},
				{58.847+51.555+240/208/4*6,240/208/4,'*16 200% Hallway','len'},
				{58.847+51.555+240/208/4*7,240/208/4,'*8 Overhead','len'},

				{112.709,114.872,'*16 200% Mini','end'},
				{112.709+240/208/8*0,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*1,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*2,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*3,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*4,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*5,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*6,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*7,240/208/8,'*64 200% Mini','len'},
				{112.709+240/208/8*7,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*7.5,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*8,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*9,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*10,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*11,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*12,240/208/4,'*64 200% Mini','len'},
				{112.709+240/208/8*12,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*12.5,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*13,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*13.5,0.050,'*10000 No Mini','len'},
				{112.709+240/208/8*14,0.050,'*10000 No Mini','len'},
				{114.872,116.000,'*16 No Mini','end'},

				{115.161,240/208/16*3,'*32 150% Drunk,*32 150% Tipsy','len'},
				{115.377,240/208/16*3,'*32 -150% Drunk,*32 -150% Tipsy','len'},
				{115.594,240/208/16*3,'*32 150% Drunk,*32 150% Tipsy','len'},
				{115.810,240/208/16*3,'*32 -150% Drunk,*32 -150% Tipsy','len'},
				{116.026,240/208/16*2,'*32 150% Drunk,*32 150% Tipsy','len'},
				{116.170,240/208/16*2,'*32 -150% Drunk,*32 -150% Tipsy','len'},
				{116.315,240/208/16*3,'*32 150% Drunk,*32 150% Tipsy','len'},
				{116.531,240/208/16*3,'*16 No Drunk,*16 No Tipsy','len'},

				{117.324,119.055,'0x','end'},
				{119.055,150.000,'*24 100x','end'},
				{119.344,150.000,'*16 Flip,*16 Dark','end'},--Replaced Blind with MessageCommands. -Kid

				}

				local inc = 1;
				for i = 16.940,18.094,240/208/16 do
					local multi = 1; if math.mod(inc,2) == 0 then multi = -1; end
					table.insert(prefix_mods,{i,240/208/16,'*'.. inc*16 .. ' '.. inc*400*multi .. '% Drunk','len'});
					--table.insert(prefix_mods,{16.940,20,'*10000 Drunk','len'});
					inc = inc + 1;
				end


				prefix_plr = {nil,nil};--Let's make this not explode if, say, only P2 exists. -Kid
				prefix_plr_wrap = {nil,nil};--There's some zoomz abuse ahead. -Kid
				prefix_proxy = {nil, nil}

				prefix_inc = 1;

				self:queuecommand('Update');
			end,
    Update2Command= function(self)
		self:sleep(0.02);
		self:queuecommand('Update');
		end,
    UpdateCommand= function(self)
			--SCREENMAN:SystemMessage("P1: "..GAMESTATE:GetPlayerState(0):GetPlayerOptionsString('ModsLevel_Song').."\nP2: "..GAMESTATE:GetPlayerState(1):GetPlayerOptionsString('ModsLevel_Song').."\nBeat: "..GAMESTATE:GetSongBeat().."\nSong Position: "..GAMESTATE:GetSongPosition():GetMusicSeconds().."\nauxvar: "..auxvar:getaux());
			prefix_inc = prefix_inc + 1;
			local beat = GAMESTATE:GetSongBeat();

			-----------------------
			-- Player mod resets --
			-----------------------
			--GAMESTATE:ApplyGameCommand('mod,clearall')
			taronuke_mods('clearall',1);
			taronuke_mods('clearall',2);

			--------------------------------------------------------------------------------------------
			-- Mod reader code originally coded by Taronuke, remade to support end times and lengths. --
			--------------------------------------------------------------------------------------------
			for i,v in pairs(prefix_mods) do
				if prefix_time >=v[1] then
					if (v[4] == 'len' and prefix_time <=v[1]+v[2]) or (v[4] == 'end' and prefix_time <=v[2]) then
						if table.getn(v) == 5 then
							--GAMESTATE:ApplyGameCommand('mod,'..v[3],v[5]);
							taronuke_mods(v[3], v[5])--From TaroNuke's mods.lua
						else
							--GAMESTATE:ApplyGameCommand('mod,'..v[3]);
							for i=1,2 do
								taronuke_mods(v[3], i)
							end
						end
					end
				end
			end



			if beat >= 0 and not checked then

				prefix_plr[1] = SCREENMAN:GetTopScreen():GetChild('PlayerP1');
				prefix_plr[2] = SCREENMAN:GetTopScreen():GetChild('PlayerP2');
				checked = true;

				SCREENMAN:GetTopScreen():GetChild('Overlay'):visible(false);
				SCREENMAN:GetTopScreen():GetChild('Underlay'):visible(false);
				if SCREENMAN:GetTopScreen():GetChild('BPMDisplay') then SCREENMAN:GetTopScreen():GetChild('BPMDisplay'):visible(false); end
				if SCREENMAN:GetTopScreen():GetChild('StageDisplay') then SCREENMAN:GetTopScreen():GetChild('StageDisplay'):visible(false); end
				if SCREENMAN:GetTopScreen():GetChild('SongTitle') then SCREENMAN:GetTopScreen():GetChild('SongTitle'):visible(false); end
				for i,v in pairs(prefix_plr) do
					if v then
						SCREENMAN:GetTopScreen():GetChild('ScoreP'..i):visible(false);
						SCREENMAN:GetTopScreen():GetChild('LifeP'..i):visible(false);
						--Hide more things. -Kid
						if SCREENMAN:GetTopScreen():GetChild('SongMeterDisplayP'..i) then SCREENMAN:GetTopScreen():GetChild('SongMeterDisplayP'..i):visible(false) end
						if SCREENMAN:GetTopScreen():GetChild('StepsDisplayP'..i) then SCREENMAN:GetTopScreen():GetChild('StepsDisplayP'..i):visible(false) end
						if SCREENMAN:GetTopScreen():GetChild('LifeMeterBarP'..i) then SCREENMAN:GetTopScreen():GetChild('LifeMeterBarP'..i):visible(false) end

						prefix_plr_wrap[i] = v:AddWrapperState();

						SCREENMAN:GetTopScreen():SetDrawByZPosition(true);
						SCREENMAN:GetTopScreen():GetChild('SongForeground'):z(-1);
						SCREENMAN:GetTopScreen():GetChild('SongBackground'):z(-999);
					end
				end
			end
			if beat >= 90.250 and fgcurcommand == 0 then--Doing some shenanigans. -Kid
				for i,v in pairs(prefix_plr) do
					if v then
						v:zoomz(prefix_height_ratio)
					end
				end
				fgcurcommand = fgcurcommand + 1;
			end
			if beat >= 91 and fgcurcommand == 1 then
				for i,v in pairs(prefix_plr) do
					if v then
						v:accelerate(240/208/8);--Did some ratios. -Kid
						v:zoomy(6.5*prefix_height_ratio);
						v:addy(650*prefix_height_ratio);
						v:decelerate(240/208/8);
						v:zoomy(12*prefix_height_ratio);
						v:addy(650*prefix_height_ratio);
					end
				end
				fgcurcommand = fgcurcommand + 1;
			end

			if beat >= 107 and fgcurcommand == 2 then
				for i,v in pairs(prefix_plr) do
					if v then
						v:decelerate(240/208/4);
						v:y(SCREEN_CENTER_Y);
						v:zoomy(prefix_height_ratio);
					end
				end
				if is_5_2 then--Slight fork in the road. -Kid
					fgcurcommand = fgcurcommand + 1;
				else
					fgcurcommand = fgcurcommand + 2;
				end
			end

			if beat >= 333 and fgcurcommand == 3 then--Force reset. -Kid
				for i,v in pairs(prefix_plr) do
					if v then
						prefix_plr_wrap[i]:y(0);
						v:y(SCREEN_CENTER_Y);
					end
				end
				fgcurcommand = fgcurcommand + 1;
			end

			if beat >= 349.5 and fgcurcommand == 4 then
				for i,v in pairs(prefix_plr) do
					if v then
						v:accelerate(240/208/4);
						v:rotationz(180);
						v:decelerate(240/208/4);
						v:rotationz(360);
					end
				end
				fgcurcommand = fgcurcommand + 1;
			end

			-------------------------
			-- BEAT SPECIFIC STUFF --
			-------------------------
			if beat > 4 and beat < 36 then
				local multi2 = 1; if math.mod(prefix_inc,2) == 0 then multi2 = -1; end
				for i,v in pairs(prefix_plr) do
					local multi = -1; if i == 2 then multi = 1; end
					if v then--Did some ratios. -Kid
						v:x(SCREEN_CENTER_X+(math.sin(beat*math.pi/2)*auxvar:getaux()*multi2)+multi*160*prefix_width_ratio);
						v:y(SCREEN_CENTER_Y+(math.cos(beat*math.pi/2)*auxvar:getaux()*multi2)*prefix_height_ratio);
					end
				end

				if prefix_bg then--Did some ratios. -Kid
					prefix_bg:x(SCREEN_CENTER_X+(math.sin(beat*math.pi/2)*auxvar:getaux()*multi2)*prefix_height_ratio);
					prefix_bg:y(SCREEN_CENTER_Y+(math.cos(beat*math.pi/2)*auxvar:getaux()*multi2)*prefix_height_ratio);
				end
			end

			if beat > 68 and beat < 90.250 then
				for i,v in pairs(prefix_plr) do
					if v then
						v:zoomz(math.max(prefix_height_ratio,math.sin(beat*math.pi*2-3)*50*prefix_width_ratio))--Scale to how wide the screen is. -Kid
					end
				end
			end

			if beat > 128.5 and beat < 133 then
				for i,v in pairs(prefix_plr) do
					if v then
						v:zoomx(prefix_height_ratio);
						v:zoomy(prefix_height_ratio);

						if beat > 129 and beat < 132 then
							v:zoomy((0.625 + math.cos(beat*math.pi*2)*0.375)*prefix_height_ratio);
						end

						if beat < 131.5 then
							v:zoomx((0.625 + math.sin(beat*math.pi*2)*0.375)*prefix_height_ratio);
						end
					end
				end
			end

			if beat > 145.5 and beat < 148 then
				local multi2 = 1; if math.mod(prefix_inc,2) == 0 then multi2 = -1; end
				--GAMESTATE:ApplyGameCommand('mod,*10000 '.. -auxvar:getaux() ..'% Mini,*10000 '..auxvar:getaux()/10 ..'% Flip');
				p1_options:Mini((-auxvar:getaux())/100,10000,true):Flip((auxvar:getaux()/10)/100,10000)
				p2_options:Mini((-auxvar:getaux())/100,10000,true):Flip((auxvar:getaux()/10)/100,10000)
				if beat > 146.5 then
					--GAMESTATE:ApplyGameCommand('mod,*10000 '.. auxvar:getaux()*multi2 ..'% Mini,*10000 '..math.max(0,auxvar:getaux()/10*multi2) ..'% Flip');
					p1_options:Mini((auxvar:getaux()*multi2)/100,10000,true):Flip((math.max(0,auxvar:getaux()/10*multi2))/100,10000)
					p2_options:Mini((auxvar:getaux()*multi2)/100,10000,true):Flip((math.max(0,auxvar:getaux()/10*multi2))/100,10000)
				end
			end

			if beat > 164 and beat < 173 then
				local multi2 = 1; if math.mod(prefix_inc,2) == 0 then multi2 = -1; end
				for i,v in pairs(prefix_plr) do
					local multi = -1; if i == 2 then multi = 1; end
					if v then
						if (beat > 165.5 and beat < 167) or
							(beat > 168.5 and beat < 170) or
							beat > 171 then
							v:x(SCREEN_CENTER_X+(math.sin(beat*math.pi/2)*auxvar:getaux()*multi2)+multi*160*prefix_width_ratio);
							v:y(SCREEN_CENTER_Y+(math.cos(beat*math.pi/2)*auxvar:getaux()*multi2)*prefix_height_ratio);
						else
							v:x(SCREEN_CENTER_X+(math.cos(beat*math.pi/2)*auxvar:getaux()*multi2)+multi*160*prefix_width_ratio);
							v:y(SCREEN_CENTER_Y+(math.sin(beat*math.pi/2)*auxvar:getaux()*multi2)*prefix_height_ratio);
						end
						if beat > 172 then
							v:x(SCREEN_CENTER_X+multi*160*prefix_width_ratio);
							v:y(SCREEN_CENTER_Y);
						end
					end
				end
			end



			if beat > 204 and beat < 236 then
				local multi2 = 1; if math.mod(prefix_inc,2) == 0 then multi2 = -1; end
				for i,v in pairs(prefix_plr) do
					local multi = -1; if i == 2 then multi = 1; end
					if v then
						v:x(SCREEN_CENTER_X+(math.sin(beat*math.pi/2)*auxvar:getaux()*multi2)+multi*160*ratioaux:getaux());
						v:y(SCREEN_CENTER_Y+(math.cos(beat*math.pi/2)*auxvar:getaux()*multi2)*prefix_height_ratio);
					end
				end

				if prefix_bg then
					prefix_bg:x(SCREEN_CENTER_X+(math.sin(beat*math.pi/2)*auxvar:getaux()*multi2)*prefix_height_ratio);
					prefix_bg:y(SCREEN_CENTER_Y+(math.cos(beat*math.pi/2)*auxvar:getaux()*multi2)*prefix_height_ratio);
				end
			end



			if beat > 164+204 and beat < 173+204 then
				local multi2 = 1; if math.mod(prefix_inc,2) == 0 then multi2 = -1; end
				for i,v in pairs(prefix_plr) do
					local multi = -1; if i == 2 then multi = 1; end
					if v then
						if (beat > 165.5+204 and beat < 167+204) or
							(beat > 168.5+204 and beat < 170+204) or
							beat > 171+204 then
							v:x(SCREEN_CENTER_X+(math.sin(beat*math.pi/2)*auxvar:getaux()*multi2)*prefix_height_ratio+multi*160*prefix_width_ratio);
							v:y(SCREEN_CENTER_Y+(math.cos(beat*math.pi/2)*auxvar:getaux()*multi2)*prefix_height_ratio);
						else
							v:x(SCREEN_CENTER_X+(math.cos(beat*math.pi/2)*auxvar:getaux()*multi2)*prefix_height_ratio+multi*160*prefix_width_ratio);
							v:y(SCREEN_CENTER_Y+(math.sin(beat*math.pi/2)*auxvar:getaux()*multi2)*prefix_height_ratio);
						end
						if beat > 172+204 then
							v:x(SCREEN_CENTER_X+multi*160*prefix_width_ratio);
							v:y(SCREEN_CENTER_Y);
						end
					end
				end
			end



			if beat > 236 and beat < 333 then
				for i,v in pairs(prefix_plr) do
					local multi = -1; if i == 2 then multi = 1; end
					if v then--The amount of scaling and messing with auxvars is absurd. -Kid
						v:x(SCREEN_CENTER_X+(math.cos(beat*math.pi/4)*multi*-160*ratioaux:getaux()));
						if is_5_2 then--I feel like I shouldn't have to do this, but oh well. -Kid
							v:y(0);
							prefix_plr_wrap[i]:y(SCREEN_CENTER_Y+auxvar:getaux()*4*prefix_height_ratio );
							prefix_plr_wrap[i]:zoomy(1+((auxvar:getaux()*(1.1))/100)*4);
							prefix_plr_wrap[i]:zoomz(pwzoomvar:getaux()+(auxvar:getaux()*(1.1))/100*4);
							v:zoomz(pzoomvar:getaux()+(auxvar:getaux()*(1.1))/100*4*prefix_width_ratio);
							v:z(math.sin(beat*math.pi/4)*(auxvar:getaux()*(1.2))*multi*2*prefix_width_ratio - auxvar:getaux()*4*prefix_width_ratio);
							v:rotationy(math.cos(beat*math.pi/4)*multi*(auxvar:getaux()*(1.3))/10);
							v:rotationz(math.sin(beat*math.pi/4)*multi*(auxvar:getaux()*(2.0))/-10);
						else
							v:y(SCREEN_CENTER_Y+(auxvar:getaux()*(1.2))*4*prefix_height_ratio);
							prefix_plr_wrap[i]:y((auxvar:getaux()*(1.2))*prefix_height_ratio)
							v:zoomy(prefix_height_ratio+(auxvar:getaux()*(1.2))/100*4*prefix_height_ratio);
							prefix_plr_wrap[i]:zoomz(pwzoomvar:getaux()+auxvar:getaux()/100*4);
							v:zoomz(pzoomvar:getaux()+auxvar:getaux()/100*4*prefix_width_ratio);
							v:z(math.sin(beat*math.pi/4)*(auxvar:getaux()*(1.1))*multi*2*prefix_width_ratio - auxvar:getaux()*4*prefix_width_ratio);
							v:rotationy(math.cos(beat*math.pi/4)*multi*(auxvar:getaux()*(2.5))/10);
							v:rotationz(math.sin(beat*math.pi/4)*multi*(auxvar:getaux()*(2.5))/-10);
						end
						--v:skewx(math.cos(beat*math.pi/4)*multi*auxvar:getaux()/20);
						--v:skewx(math.sin(beat*math.pi/4)*multi);

						if beat > 332 then
							v:x(SCREEN_CENTER_X+multi*160*ratioaux:getaux());
							if is_5_2 then
								prefix_plr_wrap[i]:y(SCREEN_CENTER_Y);
								v:y(0);
							else
								prefix_plr_wrap[i]:y(0);
								prefix_plr_wrap[i]:zoomz(pwzoomvar:getaux())
								v:zoomz(pzoomvar:getaux())
								v:y(SCREEN_CENTER_Y);
							end
						end
					end
				end
			end

			if beat > 406 and beat < 407.5 then
				for i,v in pairs(prefix_plr) do
					if v then
						v:vibrate();
						v:effectmagnitude(math.sin(beat*math.pi*2)*100,math.sin(beat*math.pi)*100,0);

						if beat > 407 then v:stopeffect(); end
					end
				end
			end

			--------------------------------------------------------------
			-- Message reader to make specific values of the actor aux. --
			--------------------------------------------------------------
			if prefix_curmessage <= table.getn(prefix_messages) then
				if prefix_time >= prefix_messages[prefix_curmessage][1] then
					MESSAGEMAN:Broadcast(prefix_messages[prefix_curmessage][2]);
					prefix_curmessage = prefix_curmessage + 1;
				end
			end

			self:queuecommand('Update2');

		end,
  },
  Def.BitmapText{
    Name= "actor_f",
    Font= "Common Normal",
    OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;effectclock,"music";playcommand,"SetTime";visible,true),
    SetTimeCommand= function(self) self:settext(self:GetSecsIntoEffect()); prefix_time = tonumber(self:GetText()); self:sleep(0.02); self:queuecommand('SetTime'); end,
    Text= "test",
  },
  Def.Quad{
    Name= "actor_g",
    BuzzBeginningRatioMessageCommand= cmd(finishtweening;sleep,240/208/8;aux,prefix_width_ratio;linear,9-240/208/8;aux,prefix_height_ratio),
    InitCommand= function(self) ratioaux = self; self:visible(false) end,
    OnCommand= cmd(aux,prefix_width_ratio),
    --PerspectiveMessageCommand= cmd(finishtweening;aux,0;linear,240/208*16;aux,100;sleep,240/208*7.5;linear,240/208/2;aux,0),
    HideVortexMessageCommand= cmd(finishtweening;aux,prefix_height_ratio;linear,0.571;aux,prefix_width_ratio),
  },
  Def.Quad{
    Name= "actor_g",
    InitCommand= function(self) pwzoomvar = self; self:visible(false) end,
    OnCommand= cmd(aux,2),
    --PerspectiveMessageCommand= cmd(finishtweening;aux,0;linear,240/208*16;aux,100;sleep,240/208*7.5;linear,240/208/2;aux,0),
    HideVortexMessageCommand= cmd(finishtweening;aux,2;decelerate,1;aux,1),
  },
  Def.Quad{
    Name= "actor_g",
    InitCommand= function(self) pzoomvar = self; self:visible(false) end,
    OnCommand= cmd(aux,2*prefix_width_ratio),
    --PerspectiveMessageCommand= cmd(finishtweening;aux,0;linear,240/208*16;aux,100;sleep,240/208*7.5;linear,240/208/2;aux,0),
    HideVortexMessageCommand= cmd(finishtweening;aux,2*prefix_width_ratio;decelerate,1;aux,prefix_height_ratio),
  },
  Def.Quad{
    Name= "actor_g",
    BuzzBeginningMessageCommand= cmd(finishtweening;linear,240/208/8;aux,200;linear,9-240/208/8;aux,0),
    BuzzBounceMessageCommand= cmd(finishtweening;aux,0;
			decelerate,240/208/4;aux,100;accelerate,240/208/8;aux,0;
			decelerate,240/208/4;aux,100;accelerate,240/208/8;aux,0;
			decelerate,240/208/4;aux,100;accelerate,240/208/8;aux,0;
			decelerate,240/208/4;aux,100;accelerate,240/208/8;aux,0;
			decelerate,240/208/8;aux,100;accelerate,240/208/8;aux,0;
			decelerate,240/208/8;aux,100;accelerate,240/208/8;aux,0),
    InitCommand= function(self) auxvar = self; self:visible(false) end,
    MiniToBuzzMessageCommand= cmd(finishtweening;aux,0;decelerate,240/208/4;aux,200;linear,240/208/4;aux,0),
    OnCommand= cmd(),
    --PerspectiveMessageCommand= cmd(finishtweening;aux,0;linear,240/208*16;aux,100;sleep,240/208*7.5;linear,240/208/2;aux,0),
    PerspectiveMessageCommand= cmd(finishtweening;aux,0;linear,240/208*16;aux,40;sleep,240/208*7.5;linear,240/208/2;aux,0),
    VortexMessageCommand= function()
			SOUND:PlayOnce( prefix_path..'lua/break2.ogg' );
		end,
    PerspectiveJudComMessageCommand= function()
			for i,v in pairs(prefix_plr) do
				if v then--Here comes some movement BS. -Kid
					v:GetChild('Judgment'):stoptweening():linear(240/208*16):addy(10):z(20*prefix_width_ratio):sleep(240/208*7.5):linear(240/208/2):addy(-10):z(0):sleep(0)
					v:GetChild('Combo'):stoptweening():linear(240/208*16):addy(10):z(20*prefix_width_ratio):sleep(240/208*7.5):linear(240/208/2):addy(-10):z(0):sleep(0)
				end
			end
		end,
    HideVortexMessageCommand= function()
			for i,v in pairs(prefix_plr) do
				if v then
					v:decelerate(1):zoomz(prefix_height_ratio)
					prefix_plr_wrap[i]:decelerate(1):zoomz(1)
				end
			end
		end,
    XStretchMessageCommand= function()
			for i,v in pairs(prefix_plr) do
				if v then
					v:accelerate(240/208/4);
					v:zoomx(4*prefix_height_ratio);
					v:bounceend(240/208/8);
					v:zoomx(prefix_height_ratio);
				end
			end
		end,
    YStretchMessageCommand= function()
			for i,v in pairs(prefix_plr) do
				if v then
					v:accelerate(240/208/4);
					v:zoomy(4*prefix_height_ratio);
					v:bounceend(240/208/8);
					v:zoomy(1*prefix_height_ratio);
				end
			end
		end,
    --This MessageCommand is for emulating Blind. -Kid
    BlindOnMessageCommand= function(self)
			for i,v in pairs(prefix_plr) do
				if v then
					v:GetChild('Judgment'):visible(false)
					v:GetChild('Combo'):visible(false)
					if v:GetChild('Combo'):GetChild('Number') then
					    v:GetChild('Combo'):GetChild('Number'):visible(false)
					end
				end
			end
		end,
    --This MessageCommand turns off the emulated Blind. -Kid
    BlindOffMessageCommand= function(self)
			for i,v in pairs(prefix_plr) do
				if v then
					v:GetChild('Judgment'):visible(true)
					v:GetChild('Combo'):visible(true)
					if v:GetChild('Combo'):GetChild('Number') then
					    v:GetChild('Combo'):GetChild('Number'):visible(true)
					end
				end
			end
		end,
  },
  Def.Quad{
    Name= "actor_h",
    InitCommand= cmd(draworder,-999),
    OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,color('#000000')),
  },
  Def.ActorFrame{
    Name= "actor_i",
    ChangeZPositionMessageCommand= function(self) self:z(998); SCREENMAN:GetTopScreen():GetChild('SongForeground'):z(-998); end,
    DismissMessageCommand= cmd(linear,240/208/2;rotationx,-45),
    FOV= 165,
    OnCommand= cmd(z,0;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y),
    PerspectiveMessageCommand= cmd(linear,10;rotationx,-45),
    VortexSpinMessageCommand= cmd(playcommand,"ShowBlackHole"),
    LoadActor('stars') .. {
      Name= "actor_j",
      File= "stars",
      OnCommand= cmd(zoom,0;z,100*prefix_height_ratio),--Scale zoom and pos. -Kid
      ShowBlackHoleCommand= cmd(zoom,0.5*prefix_height_ratio),
      _ShowBlackHoleCommand= cmd(linear,9.23;zoom,0.5*prefix_height_ratio),
    },
    Def.Sprite{
      Name= "actor_k",
      Frames= {
        {Frame= 0, Delay= 0.03},
        {Frame= 1, Delay= 0.03},
        {Frame= 2, Delay= 0.03},
        {Frame= 3, Delay= 0.03},
        {Frame= 4, Delay= 0.03},
    },
      OnCommand= cmd(zoom,0;z,20*prefix_height_ratio),--Scale pos and zoom. -Kid
      ShowBlackHoleCommand= cmd(zoom,0.5*prefix_height_ratio),
      Texture= "./portal 4x2.png",
      _ShowBlackHoleCommand= cmd(linear,9.23;zoom,0.5*prefix_height_ratio),
    },
  },
  Def.ActorFrame{
    Name= "actor_l",
    FOV= 135,
    Def.Sprite{
      Name= "actor_m",
      InitCommand= function(self) prefix_bg = self; end,
      OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomtowidth,SCREEN_WIDTH;zoomtoheight,SCREEN_HEIGHT;diffuse,color('#808080FF')),
      Texture= "background.png",
      VortexMessageCommand= cmd(diffusealpha,0),
    },
    -- First column --
    Def.Sprite{
      Name= "actor_n",
      HideCommand= cmd(visible,false),--Scaled positions, added zoom. -Kid
      OnCommand= cmd(x,80*prefix_width_ratio+160*0;y,60*prefix_height_ratio+120*0;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/01.png",
      VortexMessageCommand= function(self) self:visible(true); self:sleep(0.2); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(-100,-75)); self:rotationy(math.random(-100,-75)); self:rotationz(math.random(270,360)); self:queuecommand('Hide'); end,
    },
    Def.Sprite{
      Name= "actor_o",--Scaled positions, added zoom. -Kid
      HideCommand= cmd(visible,false),
      OnCommand= cmd(x,80*prefix_width_ratio+160*0;y,60*prefix_height_ratio+120*1*prefix_height_ratio;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/05.png",
      VortexMessageCommand= function(self) self:visible(true); self:sleep(0.1); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(-50,-25)); self:rotationy(math.random(-100,-75)); self:rotationz(math.random(180,270)); self:queuecommand('Hide'); end,
    },
    Def.Sprite{
      Name= "actor_p",--Scaled positions, added zoom. -Kid
      HideCommand= cmd(visible,false),
      OnCommand= cmd(x,80*prefix_width_ratio+160*0;y,60*prefix_height_ratio+120*2*prefix_height_ratio;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/09.png",
      VortexMessageCommand= function(self) self:visible(true); self:sleep(0.1); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(25,50)); self:rotationy(math.random(-100,-75)); self:rotationz(math.random(180,270)); self:queuecommand('Hide'); end,
    },
    Def.Sprite{
      Name= "actor_q",--Scaled positions, added zoom. -Kid
      HideCommand= cmd(visible,false),
      OnCommand= cmd(x,80*prefix_width_ratio+160*0;y,60*prefix_height_ratio+120*3*prefix_height_ratio;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/13.png",
      VortexMessageCommand= function(self) self:visible(true); self:sleep(0.2); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(75,100)); self:rotationy(math.random(-100,-75)); self:rotationz(math.random(270,360)); self:queuecommand('Hide'); end,
    },
    -- Second column --
    Def.Sprite{--Scaled positions, added zoom. -Kid
      Name= "actor_r",
      HideCommand= cmd(visible,false),
      OnCommand= cmd(x,80*prefix_width_ratio+160*1*prefix_width_ratio;y,60*prefix_height_ratio+120*0;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/02.png",
      VortexMessageCommand= function(self) self:visible(true); self:sleep(0.1); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(-100,-75)); self:rotationy(math.random(-50,-25)); self:rotationz(math.random(180,270)); self:queuecommand('Hide'); end,
    },
    Def.Sprite{--Scaled positions, added zoom. -Kid
      Name= "actor_s",
      HideCommand= cmd(visible,false),
      OnCommand= cmd(x,80*prefix_width_ratio+160*1*prefix_width_ratio;y,60*prefix_height_ratio+120*1*prefix_height_ratio;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/06.png",
      VortexMessageCommand= function(self) self:visible(true); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(-50,-25)); self:rotationy(math.random(-50,-25)); self:rotationz(math.random(90,180)); self:queuecommand('Hide'); end,
    },
    Def.Sprite{--Scaled positions, added zoom. -Kid
      Name= "actor_t",
      HideCommand= cmd(visible,false),
      OnCommand= cmd(x,80*prefix_width_ratio+160*1*prefix_width_ratio;y,60*prefix_height_ratio+120*2*prefix_height_ratio;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/10.png",
      VortexMessageCommand= function(self) self:visible(true); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(25,50)); self:rotationy(math.random(-50,-25)); self:rotationz(math.random(90,180)); self:queuecommand('Hide'); end,
    },
    Def.Sprite{--Scaled positions, added zoom. -Kid
      Name= "actor_u",
      HideCommand= cmd(visible,false),
      OnCommand= cmd(x,80*prefix_width_ratio+160*1*prefix_width_ratio;y,60*prefix_height_ratio+120*3*prefix_height_ratio;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/14.png",
      VortexMessageCommand= function(self) self:visible(true); self:sleep(0.1); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(75,100)); self:rotationy(math.random(-50,-25)); self:rotationz(math.random(180,270)); self:queuecommand('Hide'); end,
    },
    -- Third column --
    Def.Sprite{--Scaled positions, added zoom. -Kid
      Name= "actor_v",
      HideCommand= cmd(visible,false),
      OnCommand= cmd(x,80*prefix_width_ratio+160*2*prefix_width_ratio;y,60*prefix_height_ratio+120*0;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/03.png",
      VortexMessageCommand= function(self) self:visible(true); self:sleep(0.1); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(-100,-75)); self:rotationy(math.random(25,50)); self:rotationz(math.random(-270,-180)); self:queuecommand('Hide'); end,
    },
    Def.Sprite{--Scaled positions, added zoom. -Kid
      Name= "actor_w",
      HideCommand= cmd(visible,false),
      OnCommand= cmd(x,80*prefix_width_ratio+160*2*prefix_width_ratio;y,60*prefix_height_ratio+120*1*prefix_height_ratio;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/07.png",
      VortexMessageCommand= function(self) self:visible(true); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(-50,-25)); self:rotationy(math.random(25,50)); self:rotationz(math.random(-180,-90)); self:queuecommand('Hide'); end,
    },
    Def.Sprite{--Scaled positions, added zoom. -Kid
      Name= "actor_x",
      HideCommand= cmd(visible,false),
      OnCommand= cmd(x,80*prefix_width_ratio+160*2*prefix_width_ratio;y,60*prefix_height_ratio+120*2*prefix_height_ratio;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/11.png",
      VortexMessageCommand= function(self) self:visible(true); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(25,50)); self:rotationy(math.random(25,50)); self:rotationz(math.random(-180,-90)); self:queuecommand('Hide'); end,
    },
    Def.Sprite{--Scaled positions, added zoom. -Kid
      Name= "actor_y",
      HideCommand= cmd(visible,false),
      OnCommand= cmd(x,80*prefix_width_ratio+160*2*prefix_width_ratio;y,60*prefix_height_ratio+120*3*prefix_height_ratio;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/15.png",
      VortexMessageCommand= function(self) self:visible(true); self:sleep(0.1); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(75,100)); self:rotationy(math.random(25,50)); self:rotationz(math.random(-270,-180)); self:queuecommand('Hide'); end,
    },
    -- Fourth column --
    Def.Sprite{--Scaled positions, added zoom. -Kid
      Name= "actor_z",
      HideCommand= cmd(visible,false),
      OnCommand= cmd(x,80*prefix_width_ratio+160*3*prefix_width_ratio;y,60*prefix_height_ratio+120*0;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/04.png",
      VortexMessageCommand= function(self) self:visible(true); self:sleep(0.2); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(-100,-75)); self:rotationy(math.random(75,100)); self:rotationz(math.random(-360,-270)); self:queuecommand('Hide'); end,
    },
    Def.Sprite{--Scaled positions, added zoom. -Kid
      Name= "actor_A",
      HideCommand= cmd(visible,false),
      OnCommand= cmd(x,80*prefix_width_ratio+160*3*prefix_width_ratio;y,60*prefix_height_ratio+120*1*prefix_height_ratio;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/08.png",
      VortexMessageCommand= function(self) self:visible(true); self:sleep(0.1); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(-50,-25)); self:rotationy(math.random(75,100)); self:rotationz(math.random(-270,-180)); self:queuecommand('Hide'); end,
    },
    Def.Sprite{--Scaled positions, added zoom. -Kid
      Name= "actor_B",
      HideCommand= cmd(visible,false),
      OnCommand= cmd(x,80*prefix_width_ratio+160*3*prefix_width_ratio;y,60*prefix_height_ratio+120*2*prefix_height_ratio;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/12.png",
      VortexMessageCommand= function(self) self:visible(true); self:sleep(0.1); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(25,50)); self:rotationy(math.random(75,100)); self:rotationz(math.random(-270,-180)); self:queuecommand('Hide'); end,
    },
    Def.Sprite{--Scaled positions, added zoom. -Kid
      Name= "actor_C",
      HideCommand= cmd(visible,false),
      OnCommand= cmd(x,80*prefix_width_ratio+160*3*prefix_width_ratio;y,60*prefix_height_ratio+120*3*prefix_height_ratio;diffuse,color('#808080FF');zoomx,prefix_width_ratio;zoomy,prefix_height_ratio;visible,false),
      Texture= "bg pieces/16.png",
      VortexMessageCommand= function(self) self:visible(true); self:sleep(0.2); self:accelerate(2); self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); self:z(-1000); self:zoom(0); self:rotationx(math.random(75,100)); self:rotationy(math.random(75,100)); self:rotationz(math.random(-360,-270)); self:queuecommand('Hide'); end,
    },
  },
  Def.Quad{
    Name= "actor_D",
    HideVortexMessageCommand= cmd(linear,240/208;diffusealpha,1),
    InitCommand= cmd(draworder,999),
    OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,color('#00000000')),
  },
}
