return Def.ActorFrame{
  Name= "actor_nc",
  Def.ActorFrame{
    Name= "actor_oc",
    InitCommand= function()
		prefix_startable = {};
		function prefix_storestar(self)
			table.insert(prefix_startable,self);
		end
		function prefix_shootstar(self)
			for i,v in ipairs(prefix_startable) do
				if v:getaux() == 0 then
					local zoom = math.random() + 1;
					
					v:aux(1);
					v:x(SCREEN_RIGHT+150);
					v:y(math.random(SCREEN_TOP+50,SCREEN_BOTTOM-50));
					v:z((zoom-10)*prefix_sdwidth_ratio);--Scale for aspect ratio. -Kid
					v:zoom(zoom*(SCREEN_HEIGHT/480));--Scale for HD themes. -Kid
					v:rotationz(0);
					
					v:linear(math.random()*2+1);
					v:x(SCREEN_LEFT-150);
					v:rotationz(math.random(-540,-180));
					v:aux(0);
					break;
				end
			end
		end
	end,
    OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y),
    Def.Quad{
      Name= "actor_pc",
      OnCommand= cmd(zoomtowidth,SCREEN_WIDTH*1.5;zoomtoheight,SCREEN_HEIGHT*1.5;diffuse,color('#000000')),
    },
    Def.Sprite{
      Name= "actor_qc",
      OnCommand= cmd(customtexturerect,0,0,2.25,2.25;texcoordvelocity,0,-3;zoomto,SCREEN_WIDTH*1.5,SCREEN_HEIGHT*1.5;blend,"BlendMode_Add";diffusealpha,0;sleep,63.5;linear,1;diffusealpha,0.75;linear,240/185/4;zoomto,SCREEN_HEIGHT*1.5,SCREEN_WIDTH*1.5;rotationz,90;sleep,40;linear,1;diffusealpha,0),
      Texture= "stars.png",--Added an extra zoomto. -Kid
    },
    Def.Sprite{
      Name= "actor_rc",
      OnCommand= cmd(customtexturerect,0,0,3.75,3.75;texcoordvelocity,0,-3;zoomto,SCREEN_WIDTH*1.5,SCREEN_HEIGHT*1.5;blend,"BlendMode_Add";diffusealpha,0;sleep,63.5;linear,1;diffusealpha,0.75;linear,240/185/4;zoomto,SCREEN_HEIGHT*1.5,SCREEN_WIDTH*1.5;rotationz,90;sleep,40;linear,1;diffusealpha,0),
      Texture= "stars.png",--Added an extra zoomto. -Kid
    },
    Def.Sprite{
      Name= "actor_sc",
      OnCommand= cmd(y,SCREEN_CENTER_Y;vertalign,bottom;zoomtowidth,SCREEN_WIDTH;zoomtoheight,SCREEN_HEIGHT;diffusealpha,0.5;sleep,62.27;linear,240/185;zoom,0;sleep,42.8;linear,240/185/4*6;zoomtowidth,SCREEN_WIDTH;zoomtoheight,SCREEN_HEIGHT),
      Texture= "background.png",--replaced zoom,1 with zoomtos. -Kid
    },
  },
}
